/* Factory.c generated by valac 0.34.4, the Vala compiler
 * generated from Factory.vala, do not modify */

/*
 * Copyright (C) 2008,2009 Sebastian Pölsterl
 *
 * This file is part of GNOME DVB Daemon.
 *
 * GNOME DVB Daemon is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME DVB Daemon is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME DVB Daemon.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>


#define DVB_TYPE_FACTORY (dvb_factory_get_type ())
#define DVB_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_FACTORY, DVBFactory))
#define DVB_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_FACTORY, DVBFactoryClass))
#define DVB_IS_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_FACTORY))
#define DVB_IS_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_FACTORY))
#define DVB_FACTORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_FACTORY, DVBFactoryClass))

typedef struct _DVBFactory DVBFactory;
typedef struct _DVBFactoryClass DVBFactoryClass;
typedef struct _DVBFactoryPrivate DVBFactoryPrivate;

#define DVB_LOGGING_TYPE_LOGGER (dvb_logging_logger_get_type ())
#define DVB_LOGGING_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLogger))
#define DVB_LOGGING_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLoggerClass))
#define DVB_LOGGING_IS_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_LOGGER))
#define DVB_LOGGING_IS_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_LOGGER))
#define DVB_LOGGING_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_LOGGER, DVBLoggingLoggerClass))

typedef struct _DVBLoggingLogger DVBLoggingLogger;
typedef struct _DVBLoggingLoggerClass DVBLoggingLoggerClass;

#define DVB_LOGGING_TYPE_LOG_MANAGER (dvb_logging_log_manager_get_type ())
#define DVB_LOGGING_LOG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManager))
#define DVB_LOGGING_LOG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManagerClass))
#define DVB_LOGGING_IS_LOG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_LOGGING_TYPE_LOG_MANAGER))
#define DVB_LOGGING_IS_LOG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_LOGGING_TYPE_LOG_MANAGER))
#define DVB_LOGGING_LOG_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_LOGGING_TYPE_LOG_MANAGER, DVBLoggingLogManagerClass))

typedef struct _DVBLoggingLogManager DVBLoggingLogManager;
typedef struct _DVBLoggingLogManagerClass DVBLoggingLogManagerClass;

#define DVB_DATABASE_SQLITE_TYPE_SQLITE_DATABASE (dvb_database_sqlite_sqlite_database_get_type ())
#define DVB_DATABASE_SQLITE_SQLITE_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_DATABASE_SQLITE_TYPE_SQLITE_DATABASE, DVBdatabasesqliteSqliteDatabase))
#define DVB_DATABASE_SQLITE_SQLITE_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_DATABASE_SQLITE_TYPE_SQLITE_DATABASE, DVBdatabasesqliteSqliteDatabaseClass))
#define DVB_DATABASE_SQLITE_IS_SQLITE_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_DATABASE_SQLITE_TYPE_SQLITE_DATABASE))
#define DVB_DATABASE_SQLITE_IS_SQLITE_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_DATABASE_SQLITE_TYPE_SQLITE_DATABASE))
#define DVB_DATABASE_SQLITE_SQLITE_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_DATABASE_SQLITE_TYPE_SQLITE_DATABASE, DVBdatabasesqliteSqliteDatabaseClass))

typedef struct _DVBdatabasesqliteSqliteDatabase DVBdatabasesqliteSqliteDatabase;
typedef struct _DVBdatabasesqliteSqliteDatabaseClass DVBdatabasesqliteSqliteDatabaseClass;

#define DVB_DATABASE_SQLITE_TYPE_SQLITE_CONFIG_TIMERS_STORE (dvb_database_sqlite_sqlite_config_timers_store_get_type ())
#define DVB_DATABASE_SQLITE_SQLITE_CONFIG_TIMERS_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_DATABASE_SQLITE_TYPE_SQLITE_CONFIG_TIMERS_STORE, DVBdatabasesqliteSqliteConfigTimersStore))
#define DVB_DATABASE_SQLITE_SQLITE_CONFIG_TIMERS_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_DATABASE_SQLITE_TYPE_SQLITE_CONFIG_TIMERS_STORE, DVBdatabasesqliteSqliteConfigTimersStoreClass))
#define DVB_DATABASE_SQLITE_IS_SQLITE_CONFIG_TIMERS_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_DATABASE_SQLITE_TYPE_SQLITE_CONFIG_TIMERS_STORE))
#define DVB_DATABASE_SQLITE_IS_SQLITE_CONFIG_TIMERS_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_DATABASE_SQLITE_TYPE_SQLITE_CONFIG_TIMERS_STORE))
#define DVB_DATABASE_SQLITE_SQLITE_CONFIG_TIMERS_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_DATABASE_SQLITE_TYPE_SQLITE_CONFIG_TIMERS_STORE, DVBdatabasesqliteSqliteConfigTimersStoreClass))

typedef struct _DVBdatabasesqliteSqliteConfigTimersStore DVBdatabasesqliteSqliteConfigTimersStore;
typedef struct _DVBdatabasesqliteSqliteConfigTimersStoreClass DVBdatabasesqliteSqliteConfigTimersStoreClass;

#define DVB_DATABASE_SQLITE_TYPE_SQLITE_EPG_STORE (dvb_database_sqlite_sqlite_epg_store_get_type ())
#define DVB_DATABASE_SQLITE_SQLITE_EPG_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_DATABASE_SQLITE_TYPE_SQLITE_EPG_STORE, DVBdatabasesqliteSqliteEPGStore))
#define DVB_DATABASE_SQLITE_SQLITE_EPG_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_DATABASE_SQLITE_TYPE_SQLITE_EPG_STORE, DVBdatabasesqliteSqliteEPGStoreClass))
#define DVB_DATABASE_SQLITE_IS_SQLITE_EPG_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_DATABASE_SQLITE_TYPE_SQLITE_EPG_STORE))
#define DVB_DATABASE_SQLITE_IS_SQLITE_EPG_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_DATABASE_SQLITE_TYPE_SQLITE_EPG_STORE))
#define DVB_DATABASE_SQLITE_SQLITE_EPG_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_DATABASE_SQLITE_TYPE_SQLITE_EPG_STORE, DVBdatabasesqliteSqliteEPGStoreClass))

typedef struct _DVBdatabasesqliteSqliteEPGStore DVBdatabasesqliteSqliteEPGStore;
typedef struct _DVBdatabasesqliteSqliteEPGStoreClass DVBdatabasesqliteSqliteEPGStoreClass;

#define DVB_TYPE_SETTINGS (dvb_settings_get_type ())
#define DVB_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_SETTINGS, DVBSettings))
#define DVB_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_SETTINGS, DVBSettingsClass))
#define DVB_IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_SETTINGS))
#define DVB_IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_SETTINGS))
#define DVB_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_SETTINGS, DVBSettingsClass))

typedef struct _DVBSettings DVBSettings;
typedef struct _DVBSettingsClass DVBSettingsClass;

#define DVB_DATABASE_TYPE_TIMERS_STORE (dvb_database_timers_store_get_type ())
#define DVB_DATABASE_TIMERS_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_DATABASE_TYPE_TIMERS_STORE, DVBdatabaseTimersStore))
#define DVB_DATABASE_IS_TIMERS_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_DATABASE_TYPE_TIMERS_STORE))
#define DVB_DATABASE_TIMERS_STORE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_DATABASE_TYPE_TIMERS_STORE, DVBdatabaseTimersStoreIface))

typedef struct _DVBdatabaseTimersStore DVBdatabaseTimersStore;
typedef struct _DVBdatabaseTimersStoreIface DVBdatabaseTimersStoreIface;

#define DVB_TYPE_DEVICE_GROUP (dvb_device_group_get_type ())
#define DVB_DEVICE_GROUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_DEVICE_GROUP, DVBDeviceGroup))
#define DVB_DEVICE_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_DEVICE_GROUP, DVBDeviceGroupClass))
#define DVB_IS_DEVICE_GROUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_DEVICE_GROUP))
#define DVB_IS_DEVICE_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_DEVICE_GROUP))
#define DVB_DEVICE_GROUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_DEVICE_GROUP, DVBDeviceGroupClass))

typedef struct _DVBDeviceGroup DVBDeviceGroup;
typedef struct _DVBDeviceGroupClass DVBDeviceGroupClass;

#define DVB_TYPE_TIMER (dvb_timer_get_type ())
#define DVB_TIMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_TIMER, DVBTimer))
#define DVB_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_TIMER, DVBTimerClass))
#define DVB_IS_TIMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_TIMER))
#define DVB_IS_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_TIMER))
#define DVB_TIMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_TIMER, DVBTimerClass))

typedef struct _DVBTimer DVBTimer;
typedef struct _DVBTimerClass DVBTimerClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define DVB_DATABASE_TYPE_CONFIG_STORE (dvb_database_config_store_get_type ())
#define DVB_DATABASE_CONFIG_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_DATABASE_TYPE_CONFIG_STORE, DVBdatabaseConfigStore))
#define DVB_DATABASE_IS_CONFIG_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_DATABASE_TYPE_CONFIG_STORE))
#define DVB_DATABASE_CONFIG_STORE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_DATABASE_TYPE_CONFIG_STORE, DVBdatabaseConfigStoreIface))

typedef struct _DVBdatabaseConfigStore DVBdatabaseConfigStore;
typedef struct _DVBdatabaseConfigStoreIface DVBdatabaseConfigStoreIface;

#define DVB_TYPE_DEVICE (dvb_device_get_type ())
#define DVB_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_DEVICE, DVBDevice))
#define DVB_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_DEVICE, DVBDeviceClass))
#define DVB_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_DEVICE))
#define DVB_IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_DEVICE))
#define DVB_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_DEVICE, DVBDeviceClass))

typedef struct _DVBDevice DVBDevice;
typedef struct _DVBDeviceClass DVBDeviceClass;

#define DVB_TYPE_CHANNEL_GROUP (dvb_channel_group_get_type ())
#define DVB_CHANNEL_GROUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_CHANNEL_GROUP, DVBChannelGroup))
#define DVB_CHANNEL_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_CHANNEL_GROUP, DVBChannelGroupClass))
#define DVB_IS_CHANNEL_GROUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_CHANNEL_GROUP))
#define DVB_IS_CHANNEL_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_CHANNEL_GROUP))
#define DVB_CHANNEL_GROUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_CHANNEL_GROUP, DVBChannelGroupClass))

typedef struct _DVBChannelGroup DVBChannelGroup;
typedef struct _DVBChannelGroupClass DVBChannelGroupClass;

#define DVB_TYPE_CHANNEL (dvb_channel_get_type ())
#define DVB_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_CHANNEL, DVBChannel))
#define DVB_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_CHANNEL, DVBChannelClass))
#define DVB_IS_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_CHANNEL))
#define DVB_IS_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_CHANNEL))
#define DVB_CHANNEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_CHANNEL, DVBChannelClass))

typedef struct _DVBChannel DVBChannel;
typedef struct _DVBChannelClass DVBChannelClass;

#define DVB_DATABASE_TYPE_EPG_STORE (dvb_database_epg_store_get_type ())
#define DVB_DATABASE_EPG_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_DATABASE_TYPE_EPG_STORE, DVBdatabaseEPGStore))
#define DVB_DATABASE_IS_EPG_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_DATABASE_TYPE_EPG_STORE))
#define DVB_DATABASE_EPG_STORE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DVB_DATABASE_TYPE_EPG_STORE, DVBdatabaseEPGStoreIface))

typedef struct _DVBdatabaseEPGStore DVBdatabaseEPGStore;
typedef struct _DVBdatabaseEPGStoreIface DVBdatabaseEPGStoreIface;

#define DVB_TYPE_EVENT (dvb_event_get_type ())
#define DVB_EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DVB_TYPE_EVENT, DVBEvent))
#define DVB_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DVB_TYPE_EVENT, DVBEventClass))
#define DVB_IS_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DVB_TYPE_EVENT))
#define DVB_IS_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DVB_TYPE_EVENT))
#define DVB_EVENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DVB_TYPE_EVENT, DVBEventClass))

typedef struct _DVBEvent DVBEvent;
typedef struct _DVBEventClass DVBEventClass;

struct _DVBFactory {
	GObject parent_instance;
	DVBFactoryPrivate * priv;
};

struct _DVBFactoryClass {
	GObjectClass parent_class;
};

typedef enum  {
	DVB_DATABASE_SQL_ERROR_ERROR,
	DVB_DATABASE_SQL_ERROR_INTERNAL,
	DVB_DATABASE_SQL_ERROR_PERM,
	DVB_DATABASE_SQL_ERROR_ABORT,
	DVB_DATABASE_SQL_ERROR_BUSY,
	DVB_DATABASE_SQL_ERROR_LOCKED,
	DVB_DATABASE_SQL_ERROR_NOMEM,
	DVB_DATABASE_SQL_ERROR_READONLY,
	DVB_DATABASE_SQL_ERROR_INTERRUPT,
	DVB_DATABASE_SQL_ERROR_IOERR,
	DVB_DATABASE_SQL_ERROR_CORRUPT,
	DVB_DATABASE_SQL_ERROR_NOTFOUND,
	DVB_DATABASE_SQL_ERROR_FULL,
	DVB_DATABASE_SQL_ERROR_CANTOPEN,
	DVB_DATABASE_SQL_ERROR_PROTOCOL,
	DVB_DATABASE_SQL_ERROR_EMPTY,
	DVB_DATABASE_SQL_ERROR_SCHEMA,
	DVB_DATABASE_SQL_ERROR_TOOBIG,
	DVB_DATABASE_SQL_ERROR_CONSTRAINT,
	DVB_DATABASE_SQL_ERROR_MISMATCH,
	DVB_DATABASE_SQL_ERROR_MISUSE,
	DVB_DATABASE_SQL_ERROR_NOLFS,
	DVB_DATABASE_SQL_ERROR_AUTH,
	DVB_DATABASE_SQL_ERROR_FORMAT,
	DVB_DATABASE_SQL_ERROR_RANGE,
	DVB_DATABASE_SQL_ERROR_NOTADB
} DVBdatabaseSqlError;
#define DVB_DATABASE_SQL_ERROR dvb_database_sql_error_quark ()
struct _DVBdatabaseTimersStoreIface {
	GTypeInterface parent_iface;
	GeeList* (*get_all_timers_of_device_group) (DVBdatabaseTimersStore* self, DVBDeviceGroup* dev, GError** error);
	gboolean (*add_timer_to_device_group) (DVBdatabaseTimersStore* self, DVBTimer* timer, DVBDeviceGroup* dev, GError** error);
	gboolean (*remove_timer_from_device_group) (DVBdatabaseTimersStore* self, guint timer_id, DVBDeviceGroup* dev, GError** error);
	gboolean (*remove_all_timers_from_device_group) (DVBdatabaseTimersStore* self, guint group_id, GError** error);
	gboolean (*update_timer) (DVBdatabaseTimersStore* self, DVBTimer* timer, DVBDeviceGroup* dev, GError** error);
};

struct _DVBdatabaseConfigStoreIface {
	GTypeInterface parent_iface;
	GeeList* (*get_all_device_groups) (DVBdatabaseConfigStore* self, GError** error);
	DVBDeviceGroup* (*get_device_group) (DVBdatabaseConfigStore* self, guint group_id, GError** error);
	gboolean (*is_last_device) (DVBdatabaseConfigStore* self, guint group_id, GError** error);
	gboolean (*is_group_member) (DVBdatabaseConfigStore* self, DVBDevice* dev, DVBDeviceGroup* group, GError** error);
	gboolean (*add_device_group) (DVBdatabaseConfigStore* self, DVBDeviceGroup* dev_group, GError** error);
	gboolean (*remove_device_group) (DVBdatabaseConfigStore* self, DVBDeviceGroup* devgroup, GError** error);
	gboolean (*add_device_to_group) (DVBdatabaseConfigStore* self, DVBDevice* dev, DVBDeviceGroup* devgroup, GError** error);
	gboolean (*remove_device_from_group) (DVBdatabaseConfigStore* self, DVBDevice* dev, DVBDeviceGroup* devgroup, GError** error);
	gboolean (*update_from_group) (DVBdatabaseConfigStore* self, DVBDeviceGroup* devgroup, GError** error);
	gboolean (*get_parent_groups) (DVBdatabaseConfigStore* self, guint adapter, guint frontend, guint** group_ids, int* group_ids_length1, GError** error);
	gboolean (*add_channel_group) (DVBdatabaseConfigStore* self, const gchar* name, gint* channel_group_id, GError** error);
	gboolean (*remove_channel_group) (DVBdatabaseConfigStore* self, gint group_id, GError** error);
	GeeList* (*get_channel_groups) (DVBdatabaseConfigStore* self, GError** error);
	GeeList* (*get_channels_of_group) (DVBdatabaseConfigStore* self, guint dev_group_id, gint channel_group_id, GError** error);
	gboolean (*add_channel_to_group) (DVBdatabaseConfigStore* self, DVBChannel* channel, gint group_id, GError** error);
	gboolean (*remove_channel_from_group) (DVBdatabaseConfigStore* self, DVBChannel* channel, gint group_id, GError** error);
};

struct _DVBdatabaseEPGStoreIface {
	GTypeInterface parent_iface;
	gboolean (*add_or_update_event) (DVBdatabaseEPGStore* self, DVBEvent* event, guint channel_sid, guint group_id, GError** error);
	DVBEvent* (*get_event) (DVBdatabaseEPGStore* self, guint event_id, guint channel_sid, guint group_id, GError** error);
	gboolean (*remove_event) (DVBdatabaseEPGStore* self, guint event_id, guint channel_sid, guint group_id, GError** error);
	gboolean (*remove_events_older_than) (DVBdatabaseEPGStore* self, DVBEvent* event, guint channel_sid, guint group_id, GError** error);
	gboolean (*contains_event) (DVBdatabaseEPGStore* self, DVBEvent* event, guint channel_sid, guint group_id, GError** error);
	GeeList* (*get_events) (DVBdatabaseEPGStore* self, guint channel_sid, guint group_id, GError** error);
	gboolean (*remove_events_of_group) (DVBdatabaseEPGStore* self, guint group_id, GError** error);
};


static gpointer dvb_factory_parent_class = NULL;
static DVBLoggingLogger* dvb_factory_log;
static DVBLoggingLogger* dvb_factory_log = NULL;
static DVBdatabasesqliteSqliteConfigTimersStore* dvb_factory_store;
static GRecMutex __lock_dvb_factory_store = {0};
static DVBdatabasesqliteSqliteConfigTimersStore* dvb_factory_store = NULL;
static DVBdatabasesqliteSqliteEPGStore* dvb_factory_epgstore;
static GRecMutex __lock_dvb_factory_epgstore = {0};
static DVBdatabasesqliteSqliteEPGStore* dvb_factory_epgstore = NULL;
static DVBSettings* dvb_factory_settings;
static GRecMutex __lock_dvb_factory_settings = {0};
static DVBSettings* dvb_factory_settings = NULL;

GType dvb_factory_get_type (void) G_GNUC_CONST;
enum  {
	DVB_FACTORY_DUMMY_PROPERTY
};
GType dvb_logging_logger_get_type (void) G_GNUC_CONST;
GType dvb_logging_log_manager_get_type (void) G_GNUC_CONST;
DVBLoggingLogManager* dvb_logging_log_manager_getLogManager (void);
DVBLoggingLogger* dvb_logging_log_manager_getDefaultLogger (DVBLoggingLogManager* self);
GType dvb_database_sqlite_sqlite_database_get_type (void) G_GNUC_CONST;
GType dvb_database_sqlite_sqlite_config_timers_store_get_type (void) G_GNUC_CONST;
GType dvb_database_sqlite_sqlite_epg_store_get_type (void) G_GNUC_CONST;
GType dvb_settings_get_type (void) G_GNUC_CONST;
GType dvb_device_group_get_type (void) G_GNUC_CONST;
GType dvb_timer_get_type (void) G_GNUC_CONST;
GQuark dvb_database_sql_error_quark (void);
GType dvb_database_timers_store_get_type (void) G_GNUC_CONST;
DVBdatabaseTimersStore* dvb_factory_get_timers_store (DVBFactory* self);
DVBdatabasesqliteSqliteConfigTimersStore* dvb_database_sqlite_sqlite_config_timers_store_new (void);
DVBdatabasesqliteSqliteConfigTimersStore* dvb_database_sqlite_sqlite_config_timers_store_construct (GType object_type);
void dvb_database_sqlite_sqlite_database_open (DVBdatabasesqliteSqliteDatabase* self, GError** error);
void dvb_logging_logger_error (DVBLoggingLogger* self, const gchar* format, ...);
GType dvb_device_get_type (void) G_GNUC_CONST;
GType dvb_channel_group_get_type (void) G_GNUC_CONST;
GType dvb_channel_get_type (void) G_GNUC_CONST;
GType dvb_database_config_store_get_type (void) G_GNUC_CONST;
DVBdatabaseConfigStore* dvb_factory_get_config_store (DVBFactory* self);
gpointer dvb_event_ref (gpointer instance);
void dvb_event_unref (gpointer instance);
GParamSpec* dvb_param_spec_event (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void dvb_value_set_event (GValue* value, gpointer v_object);
void dvb_value_take_event (GValue* value, gpointer v_object);
gpointer dvb_value_get_event (const GValue* value);
GType dvb_event_get_type (void) G_GNUC_CONST;
GType dvb_database_epg_store_get_type (void) G_GNUC_CONST;
DVBdatabaseEPGStore* dvb_factory_get_epg_store (DVBFactory* self);
DVBdatabasesqliteSqliteEPGStore* dvb_database_sqlite_sqlite_epg_store_new (void);
DVBdatabasesqliteSqliteEPGStore* dvb_database_sqlite_sqlite_epg_store_construct (GType object_type);
DVBSettings* dvb_factory_get_settings (DVBFactory* self);
DVBSettings* dvb_settings_new (void);
DVBSettings* dvb_settings_construct (GType object_type);
gboolean dvb_settings_load (DVBSettings* self);
void dvb_factory_shutdown (DVBFactory* self);
gboolean dvb_settings_save (DVBSettings* self);
DVBFactory* dvb_factory_new (void);
DVBFactory* dvb_factory_construct (GType object_type);
static void dvb_factory_finalize (GObject* obj);


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


DVBdatabaseTimersStore* dvb_factory_get_timers_store (DVBFactory* self) {
	DVBdatabaseTimersStore* result = NULL;
	DVBdatabasesqliteSqliteConfigTimersStore* _tmp10_ = NULL;
	DVBdatabaseTimersStore* _tmp11_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	{
		DVBdatabasesqliteSqliteConfigTimersStore* _tmp0_ = NULL;
		_tmp0_ = dvb_factory_store;
		g_rec_mutex_lock (&__lock_dvb_factory_store);
		{
			DVBdatabasesqliteSqliteConfigTimersStore* _tmp1_ = NULL;
			_tmp1_ = dvb_factory_store;
			if (_tmp1_ == NULL) {
				DVBdatabasesqliteSqliteConfigTimersStore* _tmp2_ = NULL;
				_tmp2_ = dvb_database_sqlite_sqlite_config_timers_store_new ();
				_g_object_unref0 (dvb_factory_store);
				dvb_factory_store = _tmp2_;
				{
					DVBdatabasesqliteSqliteConfigTimersStore* _tmp3_ = NULL;
					_tmp3_ = dvb_factory_store;
					dvb_database_sqlite_sqlite_database_open ((DVBdatabasesqliteSqliteDatabase*) _tmp3_, &_inner_error_);
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						if (_inner_error_->domain == DVB_DATABASE_SQL_ERROR) {
							goto __catch66_dvb_database_sql_error;
						}
						{
							DVBdatabasesqliteSqliteConfigTimersStore* _tmp4_ = NULL;
							_tmp4_ = dvb_factory_store;
							g_rec_mutex_unlock (&__lock_dvb_factory_store);
						}
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return NULL;
					}
				}
				goto __finally66;
				__catch66_dvb_database_sql_error:
				{
					GError* e = NULL;
					DVBLoggingLogger* _tmp5_ = NULL;
					GError* _tmp6_ = NULL;
					const gchar* _tmp7_ = NULL;
					e = _inner_error_;
					_inner_error_ = NULL;
					_tmp5_ = dvb_factory_log;
					_tmp6_ = e;
					_tmp7_ = _tmp6_->message;
					dvb_logging_logger_error (_tmp5_, "Factory.vala:42: %s", _tmp7_);
					_g_object_unref0 (dvb_factory_store);
					dvb_factory_store = NULL;
					_g_error_free0 (e);
				}
				__finally66:
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					{
						DVBdatabasesqliteSqliteConfigTimersStore* _tmp8_ = NULL;
						_tmp8_ = dvb_factory_store;
						g_rec_mutex_unlock (&__lock_dvb_factory_store);
					}
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
			}
		}
		__finally65:
		{
			DVBdatabasesqliteSqliteConfigTimersStore* _tmp9_ = NULL;
			_tmp9_ = dvb_factory_store;
			g_rec_mutex_unlock (&__lock_dvb_factory_store);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp10_ = dvb_factory_store;
	_tmp11_ = _g_object_ref0 ((DVBdatabaseTimersStore*) _tmp10_);
	result = _tmp11_;
	return result;
}


DVBdatabaseConfigStore* dvb_factory_get_config_store (DVBFactory* self) {
	DVBdatabaseConfigStore* result = NULL;
	DVBdatabasesqliteSqliteConfigTimersStore* _tmp10_ = NULL;
	DVBdatabaseConfigStore* _tmp11_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	{
		DVBdatabasesqliteSqliteConfigTimersStore* _tmp0_ = NULL;
		_tmp0_ = dvb_factory_store;
		g_rec_mutex_lock (&__lock_dvb_factory_store);
		{
			DVBdatabasesqliteSqliteConfigTimersStore* _tmp1_ = NULL;
			_tmp1_ = dvb_factory_store;
			if (_tmp1_ == NULL) {
				DVBdatabasesqliteSqliteConfigTimersStore* _tmp2_ = NULL;
				_tmp2_ = dvb_database_sqlite_sqlite_config_timers_store_new ();
				_g_object_unref0 (dvb_factory_store);
				dvb_factory_store = _tmp2_;
				{
					DVBdatabasesqliteSqliteConfigTimersStore* _tmp3_ = NULL;
					_tmp3_ = dvb_factory_store;
					dvb_database_sqlite_sqlite_database_open ((DVBdatabasesqliteSqliteDatabase*) _tmp3_, &_inner_error_);
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						if (_inner_error_->domain == DVB_DATABASE_SQL_ERROR) {
							goto __catch68_dvb_database_sql_error;
						}
						{
							DVBdatabasesqliteSqliteConfigTimersStore* _tmp4_ = NULL;
							_tmp4_ = dvb_factory_store;
							g_rec_mutex_unlock (&__lock_dvb_factory_store);
						}
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return NULL;
					}
				}
				goto __finally68;
				__catch68_dvb_database_sql_error:
				{
					GError* e = NULL;
					DVBLoggingLogger* _tmp5_ = NULL;
					GError* _tmp6_ = NULL;
					const gchar* _tmp7_ = NULL;
					e = _inner_error_;
					_inner_error_ = NULL;
					_tmp5_ = dvb_factory_log;
					_tmp6_ = e;
					_tmp7_ = _tmp6_->message;
					dvb_logging_logger_error (_tmp5_, "Factory.vala:57: %s", _tmp7_);
					_g_object_unref0 (dvb_factory_store);
					dvb_factory_store = NULL;
					_g_error_free0 (e);
				}
				__finally68:
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					{
						DVBdatabasesqliteSqliteConfigTimersStore* _tmp8_ = NULL;
						_tmp8_ = dvb_factory_store;
						g_rec_mutex_unlock (&__lock_dvb_factory_store);
					}
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
			}
		}
		__finally67:
		{
			DVBdatabasesqliteSqliteConfigTimersStore* _tmp9_ = NULL;
			_tmp9_ = dvb_factory_store;
			g_rec_mutex_unlock (&__lock_dvb_factory_store);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp10_ = dvb_factory_store;
	_tmp11_ = _g_object_ref0 ((DVBdatabaseConfigStore*) _tmp10_);
	result = _tmp11_;
	return result;
}


DVBdatabaseEPGStore* dvb_factory_get_epg_store (DVBFactory* self) {
	DVBdatabaseEPGStore* result = NULL;
	DVBdatabasesqliteSqliteEPGStore* _tmp10_ = NULL;
	DVBdatabaseEPGStore* _tmp11_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	{
		DVBdatabasesqliteSqliteEPGStore* _tmp0_ = NULL;
		_tmp0_ = dvb_factory_epgstore;
		g_rec_mutex_lock (&__lock_dvb_factory_epgstore);
		{
			DVBdatabasesqliteSqliteEPGStore* _tmp1_ = NULL;
			_tmp1_ = dvb_factory_epgstore;
			if (_tmp1_ == NULL) {
				DVBdatabasesqliteSqliteEPGStore* _tmp2_ = NULL;
				_tmp2_ = dvb_database_sqlite_sqlite_epg_store_new ();
				_g_object_unref0 (dvb_factory_epgstore);
				dvb_factory_epgstore = _tmp2_;
				{
					DVBdatabasesqliteSqliteEPGStore* _tmp3_ = NULL;
					_tmp3_ = dvb_factory_epgstore;
					dvb_database_sqlite_sqlite_database_open ((DVBdatabasesqliteSqliteDatabase*) _tmp3_, &_inner_error_);
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						if (_inner_error_->domain == DVB_DATABASE_SQL_ERROR) {
							goto __catch70_dvb_database_sql_error;
						}
						{
							DVBdatabasesqliteSqliteEPGStore* _tmp4_ = NULL;
							_tmp4_ = dvb_factory_epgstore;
							g_rec_mutex_unlock (&__lock_dvb_factory_epgstore);
						}
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return NULL;
					}
				}
				goto __finally70;
				__catch70_dvb_database_sql_error:
				{
					GError* e = NULL;
					DVBLoggingLogger* _tmp5_ = NULL;
					GError* _tmp6_ = NULL;
					const gchar* _tmp7_ = NULL;
					e = _inner_error_;
					_inner_error_ = NULL;
					_tmp5_ = dvb_factory_log;
					_tmp6_ = e;
					_tmp7_ = _tmp6_->message;
					dvb_logging_logger_error (_tmp5_, "Factory.vala:72: %s", _tmp7_);
					_g_object_unref0 (dvb_factory_epgstore);
					dvb_factory_epgstore = NULL;
					_g_error_free0 (e);
				}
				__finally70:
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					{
						DVBdatabasesqliteSqliteEPGStore* _tmp8_ = NULL;
						_tmp8_ = dvb_factory_epgstore;
						g_rec_mutex_unlock (&__lock_dvb_factory_epgstore);
					}
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
			}
		}
		__finally69:
		{
			DVBdatabasesqliteSqliteEPGStore* _tmp9_ = NULL;
			_tmp9_ = dvb_factory_epgstore;
			g_rec_mutex_unlock (&__lock_dvb_factory_epgstore);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp10_ = dvb_factory_epgstore;
	_tmp11_ = _g_object_ref0 ((DVBdatabaseEPGStore*) _tmp10_);
	result = _tmp11_;
	return result;
}


DVBSettings* dvb_factory_get_settings (DVBFactory* self) {
	DVBSettings* result = NULL;
	DVBSettings* _tmp5_ = NULL;
	DVBSettings* _tmp6_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	{
		DVBSettings* _tmp0_ = NULL;
		_tmp0_ = dvb_factory_settings;
		g_rec_mutex_lock (&__lock_dvb_factory_settings);
		{
			DVBSettings* _tmp1_ = NULL;
			_tmp1_ = dvb_factory_settings;
			if (_tmp1_ == NULL) {
				DVBSettings* _tmp2_ = NULL;
				DVBSettings* _tmp3_ = NULL;
				_tmp2_ = dvb_settings_new ();
				_g_object_unref0 (dvb_factory_settings);
				dvb_factory_settings = _tmp2_;
				_tmp3_ = dvb_factory_settings;
				dvb_settings_load (_tmp3_);
			}
		}
		__finally71:
		{
			DVBSettings* _tmp4_ = NULL;
			_tmp4_ = dvb_factory_settings;
			g_rec_mutex_unlock (&__lock_dvb_factory_settings);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp5_ = dvb_factory_settings;
	_tmp6_ = _g_object_ref0 (_tmp5_);
	result = _tmp6_;
	return result;
}


void dvb_factory_shutdown (DVBFactory* self) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		DVBSettings* _tmp0_ = NULL;
		_tmp0_ = dvb_factory_settings;
		g_rec_mutex_lock (&__lock_dvb_factory_settings);
		{
			DVBSettings* _tmp1_ = NULL;
			_tmp1_ = dvb_factory_settings;
			if (_tmp1_ != NULL) {
				DVBSettings* _tmp2_ = NULL;
				_tmp2_ = dvb_factory_settings;
				dvb_settings_save (_tmp2_);
			}
		}
		__finally72:
		{
			DVBSettings* _tmp3_ = NULL;
			_tmp3_ = dvb_factory_settings;
			g_rec_mutex_unlock (&__lock_dvb_factory_settings);
		}
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


DVBFactory* dvb_factory_construct (GType object_type) {
	DVBFactory * self = NULL;
	self = (DVBFactory*) g_object_new (object_type, NULL);
	return self;
}


DVBFactory* dvb_factory_new (void) {
	return dvb_factory_construct (DVB_TYPE_FACTORY);
}


static void dvb_factory_class_init (DVBFactoryClass * klass) {
	DVBLoggingLogManager* _tmp0_ = NULL;
	DVBLoggingLogger* _tmp1_ = NULL;
	dvb_factory_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = dvb_factory_finalize;
	_tmp0_ = dvb_logging_log_manager_getLogManager ();
	_tmp1_ = dvb_logging_log_manager_getDefaultLogger (_tmp0_);
	dvb_factory_log = _tmp1_;
	g_rec_mutex_init (&__lock_dvb_factory_store);
	g_rec_mutex_init (&__lock_dvb_factory_epgstore);
	g_rec_mutex_init (&__lock_dvb_factory_settings);
}


static void dvb_factory_instance_init (DVBFactory * self) {
}


static void dvb_factory_finalize (GObject* obj) {
	DVBFactory * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DVB_TYPE_FACTORY, DVBFactory);
	G_OBJECT_CLASS (dvb_factory_parent_class)->finalize (obj);
}


GType dvb_factory_get_type (void) {
	static volatile gsize dvb_factory_type_id__volatile = 0;
	if (g_once_init_enter (&dvb_factory_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DVBFactoryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dvb_factory_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DVBFactory), 0, (GInstanceInitFunc) dvb_factory_instance_init, NULL };
		GType dvb_factory_type_id;
		dvb_factory_type_id = g_type_register_static (G_TYPE_OBJECT, "DVBFactory", &g_define_type_info, 0);
		g_once_init_leave (&dvb_factory_type_id__volatile, dvb_factory_type_id);
	}
	return dvb_factory_type_id__volatile;
}



